// ======================================================================================================================================
// **********************************************  SEQ-UFD V2 BY CAVISYNTH - COPYRIGHT 2017  ********************************************
// **********************************************  www.cavisynth.com - info@cavisynth.com  **********************************************
// **********************************************  Stéphane Caviglioli  *****************************************************************
// **********************************************  V2-000  | 06.03.2017 *****************************************************************
// **********************************************  You can use and modify this code but you can not own it and redistribute it **********
// ======================================================================================================================================
#include <EEPROM.h>

int addr = 0; //eprom adresse départ

int OUT_FORWARD[] = { 6 ,5 ,4 ,10 ,11 ,9 ,8 ,7 }; // Sequencer outpouts pins forward
int OUT_BACKWARD[] = { 7 ,8 ,9 ,11 ,10 ,4 ,5 ,6 }; // Sequencer outpouts backward
int OUT_ZIGZAG[] = { 6, 11, 5, 9, 4, 8, 10, 7 }; // Sequencer outpouts zigzag
int CLOCK_SOURCE = 0; // Source de la clock ( 0 = interne | 1 = externe)
int MODE = 1; // Mode par défaut du séquenceur  (1 = forward | 2 = backward | 3 = forward-backward | 4 = random)
int STEP,STEP_RAND = 0; // Step courant + step random
int FORWARD = 1; // Sens par defaut pour mode 3 & 4
int LAST_STEP = 0; //Dernier Step
int LAST_STEPS = 0; //Dernier nombre de seps
int LAST_MODE ; // Dernier mode
int STEPS = 8; //Nombre de pas par défaut
int SUBDS = 1; //Subdivision par defaut
int LAST_SUBDS = 1;//Derniere subdivision par defaut
int INT_CLOCK; //Tempo interne
int SUPERMODE = 1; //Supermode de base (1 = séquenceur | 2 = clock divider )
int SUBD[] = {0,0,0,0,0,0,0,0}; //Step répétition (clock div)
int i; // Variable d'incrément-décrément
int count = 0; // Variable de compteur
int reset, last_reset, reset_block = 0; //Variables pour le reset
int change, last_change; //Variables pour la clock externe
//****************************************************** EXTERNAL CLOCK
int INPUT_CLOCK = 2; // Clock input pin
int INPUT_RESET = 3; // Reset input pin
int state,last_state = 0 ;
int debounce = 5;
//****************************************************** TRIGGER
int TRIGGER_OUT = 13; // pin de trigger out
int TRIGGER_OUT_STATE = HIGH;             // ledState used to set the LED
int TRIGGER_LENGHT = 70; //Longueur du signal trigger en ms
unsigned long previousMillis,previousMillisTrigger = 0;        // will store last time LED was updated

//**************************************************************************************************************************** SETUP
//**********************************************************************************************************************************
void setup() {
 analogWrite(TRIGGER_OUT, 0); //Trigger out à 0
 for(i=0; i<8;i++){pinMode(OUT_FORWARD[i], OUTPUT);} // Pin des steps en mode output
 for(i=0; i<8;i++){pinMode(OUT_BACKWARD[i], OUTPUT);} // Pin des steps en mode output
 pinMode(TRIGGER_OUT, OUTPUT); //Sortie de la LED & Trigger
 pinMode(INPUT_CLOCK, INPUT);
 pinMode(INPUT_RESET, INPUT);
 pinMode(A3, INPUT);

 // SEQUENCE INITIALISATION SEQUENCEUR
if( analogRead(A2) < 1010){ 
   for(i=0;i<8;i++){ digitalWrite(OUT_FORWARD[i], HIGH); delay(50); }
   for(i=7;i>-1;i--){ digitalWrite(OUT_FORWARD[i], LOW); delay(50);}
   for(i=8;i>-1;i--){ digitalWrite(OUT_FORWARD[i], HIGH); delay(50);}
   for(i=-1;i<8;i++){ digitalWrite(OUT_FORWARD[i], LOW); delay(50);}
   delay(80); 
}

// SEQUENCE INITIALISATION CLOCKDIV

if( analogRead(A2) > 1010){ 
      SUPERMODE = 2; 
    for(i=0;i<8;i++){ digitalWrite(OUT_FORWARD[i], HIGH);  }
    delay(150);
    for(i=0;i<8;i++){ digitalWrite(OUT_FORWARD[i], LOW);}
    delay(150);
    for(i=0;i<8;i++){ digitalWrite(OUT_FORWARD[i], HIGH);}
    delay(150);
    for(i=0;i<8;i++){ digitalWrite(OUT_FORWARD[i], LOW);}
        
  } 

} //Setup

//************************************************************************************************************************ FUNCTIONS
//**********************************************************************************************************************************
void step_reset(){  //************************************************ RESEST
       reset = digitalRead(3);
       if(reset != last_reset){ 
         reset_block = 1;
         STEP = 0;
         LAST_STEP = 0;
         STEPS = 0;
         count = 0;
         digitalWrite(OUT_FORWARD[STEP],LOW);
         for(i=0; i<8;i++){  digitalWrite(OUT_FORWARD[i], LOW);}
         for(i=0; i<8;i++){  digitalWrite(OUT_BACKWARD[i], LOW);}
         digitalWrite(TRIGGER_OUT, LOW); // Eteint la led du trigger
          reset_block = 0;
       }
       last_reset = reset;
       delay(debounce);
}

void  trigger_out(int S){ //************************************************** ENVOI DU TRIGGER
  if(S != LAST_STEP){
      unsigned long currentMillisTrigger = millis();
      if (currentMillisTrigger - previousMillisTrigger >= TRIGGER_LENGHT ) {
          previousMillisTrigger = currentMillisTrigger;
          digitalWrite(TRIGGER_OUT, HIGH); 
          delay(debounce);
     } digitalWrite(TRIGGER_OUT, LOW); 
  }
  LAST_STEP = S;
}


void step_change_clock(){  //******************************************* AVANCE CLOCK EXTERNE
     if(CLOCK_SOURCE == 1 && reset_block == 0){
      change = digitalRead(2);
      if(change != last_change){
      digitalWrite(TRIGGER_OUT, TRIGGER_OUT_STATE); 
      TRIGGER_OUT_STATE = !TRIGGER_OUT_STATE;
      state = !state;      
      }
      last_change = change;
      delay(debounce);
      }
}

void step_change_int(){ //******************************************* AVANCE TEMPO INTERNE
     if(CLOCK_SOURCE == 0 &&  reset_block == 0){
     INT_CLOCK = map(analogRead(A2), 20, 1023, 2500, 20);} 
     unsigned long currentMillis = millis();
     if (currentMillis - previousMillis >= INT_CLOCK/2) {
      previousMillis = currentMillis;
      //digitalWrite(TRIGGER_OUT, TRIGGER_OUT_STATE); 
      //TRIGGER_OUT_STATE = !TRIGGER_OUT_STATE;
      state = !state;
      delay(debounce);
     }
}
//***************************************************************************************************************************** LOOP
//**********************************************************************************************************************************
void loop() {
  
step_reset(); // Veille sur le reset 
 
//****************************************** SELECTION DE LA SOURCE DE CLOCK (INT / EXT)
  if( analogRead(A2)<=20){CLOCK_SOURCE = 1;  step_change_clock(); } 
  if( analogRead(A2)>20){ CLOCK_SOURCE = 0;  step_change_int();} 
 //****************************************** SELECTION DE LA SOURCE DE CLOCK (INT / EXT)
if( SUPERMODE == 1){ 
// =======================================================================================> LECTURE DU POTENTIOMETRE DE MODESELEKTOR 
      if(analogRead(A1) <= 120){MODE = 1;} //MODE STEP SELECT
      if(analogRead(A1) > 120 && analogRead(A1) <= 320){MODE = 2;} //MODE STEP FORWARD
      if(analogRead(A1) > 320 && analogRead(A1) <= 460){MODE = 3;} //MODE STEP BACKWARD
      if(analogRead(A1) > 460 && analogRead(A1) <= 620){MODE = 4;} //MODE STEP FORWARD - BACKWARD
      if(analogRead(A1) > 620 && analogRead(A1) <= 800){MODE = 5;} //MODE STEP BACKWARD - FORWARD
      if(analogRead(A1) > 800 && analogRead(A1) <= 970){MODE = 6;} //MODE STEP RANDOM
      if(analogRead(A1) > 970){MODE = 7;} //MODE 
      if(MODE != LAST_MODE){STEP = 0; }  
      LAST_MODE = MODE; //RESET SI CHANGEMENT DE MODE  !IMPORTANT!
// =======================================================================================> LECTURE DES POTENTIOMETRES
//***************************************** SELECTION DU NOMBRE DE PAS
   if(analogRead(A0) <= 60){STEPS = 2;}
   if(analogRead(A0)> 60 && analogRead(A0) <= 230 ){STEPS = 3;}
   if(analogRead(A0)> 230 && analogRead(A0) <= 410 ){STEPS = 4;}
   if(analogRead(A0)> 410 && analogRead(A0) <= 550 ){STEPS = 5;}
   if(analogRead(A0)> 550 && analogRead(A0) <= 730 ){STEPS = 6;}
   if(analogRead(A0)> 730 && analogRead(A0) <= 910 ){STEPS = 7;}
   if(analogRead(A0) > 910){STEPS = 8;}
   if(STEPS != LAST_STEPS && STEPS < STEP){STEP = 0;}
     // LAST_STEPS = STEPS;
 //***************************************** SELECTION DU NOMBRE DE PAS
}

//********************************************************************************* SUPERMODE = 2
 if (SUPERMODE == 2){
    //****************************************************** TRIGGER SEQUENCER
    STEPS = map(analogRead(A0), 0, 1023, 0, 7); // SELECTION DE LA SORTIE  TRIGGER (1-8)
    SUBDS = map(analogRead(A1), 21, 1023, 8, 1); // SELECTION DU NOMBRE DE SUBDIVISION DE CLOCK
    
    if(SUBD[STEPS] == 0){ //Selection visuelle du pas
      digitalWrite(OUT_FORWARD[STEPS], HIGH); 
      delay(10); 
      digitalWrite(OUT_FORWARD[STEPS], LOW); 
    } 
    if (analogRead(A1)<20){SUBDS = 0;} // Anulation DU NOMBRE DE SUBDIVISION DE CLOCK 

   for(i=0;i<8;i++){ // Lecture de la dernière sauvegarde EPROM
    SUBD[i] = EEPROM.read(i);
   }
   
  if(SUBDS != LAST_SUBDS){ 
    for(i=0;i<8;i++){ //Assigne le nombre de division pour chaque pas
      if(STEPS == i){SUBD[i] = SUBDS;} 
      EEPROM.write(addr, SUBD[i]); //Mise en mémoire EPROM
      addr = addr + 1;
      if (addr == 8) {addr = 0;}
   }
  } 
   LAST_SUBDS = SUBDS;
  
 if(STEP != LAST_STEP){
      unsigned long currentMillisTrigger = millis();
      if (currentMillisTrigger - previousMillisTrigger >= TRIGGER_LENGHT ) {
          previousMillisTrigger = currentMillisTrigger;     
          for(i=0;i<8;i++){ if(STEP%SUBD[i] == 0 && SUBD[i]!=0){ digitalWrite(OUT_FORWARD[i], HIGH); } }
            digitalWrite(TRIGGER_OUT, HIGH); 
            delay(debounce);
        } for(i=0;i<8;i++){ digitalWrite(OUT_FORWARD[i], LOW);}
            digitalWrite(TRIGGER_OUT, LOW);     
                   
  }
     LAST_STEP = STEP;
    STEP = STEP+state;
    state = 0;
    //if(STEP == 7){STEP = 0;}

//****************************************************** TRIGGER SEQUENCER
  
 }//fin supermode = 2
//********************************************************************************* SUPERMODE = 2



//********************************************************************************* SUPERMODE = 1
if (SUPERMODE == 1){
//****************************************************** MODE STEP SELECT
if(MODE == 1){ 
    STEP = map(analogRead(A0), 0, 1023, 0, 7); // SELECTION DU NOMBRE DE PAS
    digitalWrite(TRIGGER_OUT, HIGH);        // TRIGGER
    digitalWrite(OUT_FORWARD[LAST_STEP], LOW);
    digitalWrite(OUT_FORWARD[STEP], HIGH);
    LAST_STEP = STEP;
    //delay(debounce*10);
 }
//****************************************************** MODE STEP SELECT
//****************************************************** ROUTINE FORWARD
if(MODE == 2){     
    for(i=0;i<8;i++){ digitalWrite(OUT_FORWARD[i], LOW);}                                 
    digitalWrite(OUT_FORWARD[STEP], HIGH);
    trigger_out(STEP);
    STEP = STEP+state;
    state = 0;
    if(STEP == STEPS){STEP = 0;}
 }
//****************************************************** ROUTINE FORWARD
//****************************************************** ROUTINE BACKWARD
if(MODE == 3){
    for(i=0;i<8;i++){ digitalWrite(OUT_BACKWARD[i], LOW);}
    digitalWrite(OUT_BACKWARD[STEP], HIGH);
    trigger_out(STEP);
    STEP = STEP+state;
    state = 0;
    if(STEP == STEPS){STEP = 0;}
  }
//****************************************************** ROUTINE BACKWARD
//****************************************************** ROUTINE FORWARD-BACKWARD
if(MODE == 4){
  if(FORWARD == 1){
    for(i=0;i<8;i++){  digitalWrite(OUT_FORWARD[i], LOW);}
    digitalWrite(OUT_FORWARD[STEP], HIGH);
    trigger_out(STEP);
    STEP = STEP+state;
    state = 0;
    if(STEP == STEPS-1){STEP = 0; FORWARD = 0;}
  }

  if(FORWARD == 0){
    for(i=0;i<8;i++){  digitalWrite(OUT_BACKWARD[i], LOW);}
    digitalWrite(OUT_BACKWARD[STEP+(8-STEPS)], HIGH);
    trigger_out(STEP);
    STEP = STEP+state;
    state = 0;
    if(STEP == STEPS-1){STEP = 0; FORWARD = 1;}
  }
   }
//****************************************************** ROUTINE FORWARD-BACKWARD
//****************************************************** KRAB BY STEP 1
if(MODE == 5){  
    if(STEP == 0) { STEP = 1;}
    for(i=0;i<8;i++){ digitalWrite(OUT_FORWARD[i], LOW);}
    if(count%2 != 0){digitalWrite(OUT_FORWARD[0], HIGH); trigger_out(0);}
    if(count%2 == 0){digitalWrite(OUT_FORWARD[STEP], HIGH);  trigger_out(STEP);}
    count = count + state;
    if(count%2 != 0){ state = 0;}
    STEP = STEP+state;
    state = 0;
    if(STEP == STEPS){STEP = 0;}     
}
//****************************************************** OKTAV BY STEP 1
//****************************************************** ZIGZAG
if(MODE == 6){    
    for(i=0;i<8;i++){ digitalWrite(OUT_FORWARD[i], LOW);}                                 
    digitalWrite(OUT_ZIGZAG[STEP], HIGH);
    trigger_out(STEP);
    STEP = STEP+state;
    state = 0;
    if(STEP == STEPS){STEP = 0;}
}
//****************************************************** ZIGZAG
//****************************************************** ROUTINE RANDOM SANS REPETITION
if(MODE == 7){                        
    if(LAST_STEP != STEP){
       for(i=0;i<8;i++){ digitalWrite(OUT_FORWARD[i], LOW);}  
       STEP_RAND = random(0,STEPS);  
       digitalWrite(OUT_FORWARD[STEP_RAND], HIGH);
       trigger_out(STEP);
     }
    LAST_STEP = STEP;
    STEP = STEP+state;
    state = 0;  
    if(STEP == STEPS){STEP = 0;}
 }
//****************************************************** ROUTINE RANDOM
   } // fin supermode = 1
//********************************************************************************* SUPERMODE = 1
} // FIN VOID LOOP



